

#include "global.h"
#include "dataio.h"
#include "dismailbox.h"
#include "discoord.h"


/* ******************************************************************
****************************************************************** */
void dispost_office_type::update_mailboxes() {

   mailbox_type *ptr;
   message_type *btr;
   sfile sbuffer;
   int type, size;
   int version, ex;
   
   for (ptr = (mailbox_type *)mailbox_list.head; ptr; ptr = (mailbox_type *)ptr->next)
      while (ptr->mailslot->query_message_raw(&tbuffer, sizeof(DIS_header_type))) {
         sbuffer.dest();
         sbuffer.scan_data(&tbuffer);

         version = sbuffer.scan_char();
         ex = sbuffer.scan_char();
         if (ex != dis_exercise_id) {
            sbuffer.skip(6);
            size = sbuffer.scan_ushort();
            sprintf(perror_buffer, "Warning: received pdu for different exercise %d vs %d\n", ex, dis_exercise_id);
            pprintf(perror_buffer);

//          if (!ptr->mailslot->receive_message_raw(&tbuffer, size>>3))
            if (!ptr->mailslot->receive_message_raw(&tbuffer, size))
               break;

            continue;
         }

         if (version != DIS_PDU_VERSION) {
            sprintf(perror_buffer, "Warning:  Received wrong PDU version %d, expected %d\n", version, DIS_PDU_VERSION);
            pprintf(perror_buffer);
         }
	    
         type = sbuffer.scan_char();
         sbuffer.skip(5);
         size = sbuffer.scan_ushort();

//       if (!ptr->mailslot->receive_message_raw(&tbuffer, size>>3))
         if (!ptr->mailslot->receive_message_raw(&tbuffer, size))
            break;

         switch (type) {
            // note: coincidence that ES, FIRE, DETONATE have the same initial bit structure
            case DIS_PDU_TYPE_ENTITY_STATE:
            case DIS_PDU_TYPE_FIRE:
            case DIS_PDU_TYPE_DETONATE:
            case DIS_PDU_TYPE_ACTION_REQUEST:
            case DIS_PDU_TYPE_ACTION_RESPONSE:
            case DIS_PDU_TYPE_EMISSIONS:
               sbuffer.dest();
               sbuffer.scan_data(&tbuffer);
 
               sbuffer.skip(12);
               if (sbuffer.scan_ushort() != dis_site_id || sbuffer.scan_ushort() != dis_application_id) {
                  message_list.append(btr = new message_type, NULL);
                  btr->buffer.buffercpy(&tbuffer);
               }

               break;

            default:
               sprintf(perror_buffer, "Warning:  Ignoring PDU type %d\n", type);
               pprintf(perror_buffer);
               break;
         }

      }

}


/* ******************************************************************
****************************************************************** */
int dispost_office_type::send_message(buffer_type *buffer) {

   if (!mailbox_list.head)
      return 0;

   ((mailbox_type *)mailbox_list.head)->mailslot->send_message_raw(buffer);
   return 1;
}

